<?php 
	
	global  $wpdb;
	
	$space = 30;
	
	function mymail_check_port($host, $port){
		
		if(!function_exists( 'fsockopen' )) return 'requires fsockopen to check ports.';
		
		$conn = fsockopen($host, $port, $errno, $errstr, 5);
		
		$return = (is_resource($conn) ? '(' . getservbyport($port, 'tcp') . ') open.' : 'closed ['.$errstr.']');
		
		is_resource($conn) ? fclose($conn) : '';
		
		return $return;
		
	}
	
	require_once MYMAIL_DIR . '/classes/mail.class.php';
	$mail = mymail_mail::get_instance();
	//valid mail from amazon
	$mail->to = 'deadend@newsletter-plugin.com';
	$mail->subject = 'test';
	
	if($mail->send_notification( 'Sendtest', 'this testmessage can get deleted', array('notification' => ''), false )){
		$send_success = 'OK';
	}else{
		$send_success = strip_tags($mail->get_errors());
	}
	
	$lasthit = get_option('mymail_cron_lasthit', array());
	
	$settings = array(
		"SITE_URL" =>              site_url() ,
		"HOME_URL" =>              home_url() ,
		'--',
		"MyMail Version" =>        MYMAIL_VERSION ,
		"WordPress Version" =>     get_bloginfo( 'version' ) ,
		"MyMail Purchasecode" =>   mymail_option('purchasecode', 'Not defined') ,
		'--',
		"Newsletter Homepage" =>   get_permalink( mymail_option('homepage') ) ,
		"Track Countries" =>       mymail_option('trackcountries') ? 'Yes' : 'No' ,
		"Country DB" =>            file_exists(mymail_option('countries_db')) ? 'DB exists ('.date('Y-m-d H:i:s', filemtime(mymail_option('countries_db'))).', '.human_time_diff(filemtime(mymail_option('countries_db'))).')' : 'DB is missing',
		"Track Cities" =>          mymail_option('trackcities') ? 'Yes' : 'No' ,
		"City DB" =>               file_exists(mymail_option('cities_db')) ? 'DB exists ('.date('Y-m-d H:i:s', filemtime(mymail_option('cities_db'))).', '.human_time_diff(filemtime(mymail_option('cities_db'))).')' : 'DB is missing',
		'--',
		"Cron Service" =>          mymail_option('cron_service'),
		"Cron URL" =>              MYMAIL_URI.'/cron.php?'.mymail_option('cron_secret'),
		"Cron Interval" =>         mymail_option('interval').' MIN',
		"Cron Lasthit" =>          !empty($lasthit['timestamp']) ? (date('Y-m-d H:i:s', $lasthit['timestamp']).', '.human_time_diff($lasthit['timestamp'])) : 'NEVER',
		'--',
		"Delivery Method" =>       mymail_option('deliverymethod'),
		"Send at once" =>          mymail_option('send_at_once'),
		"Send limit" =>            mymail_option('send_limit'),
		"Send period" =>           mymail_option('send_period'),
		'--',
		"Test Mail" =>             $send_success,
		'--',
		"Port 110" =>              mymail_check_port('pop.bizmail.yahoo.com', 110),
		"Port 995" =>              mymail_check_port('pop.gmail.com', 995),
		"Port 993" =>              mymail_check_port('smtp.gmail.com', 993),
		"Port 25" =>               mymail_check_port('smtp.gmail.com', 25),
		"Port 465" =>              mymail_check_port('smtp.gmail.com', 465),
		"Port 587" =>              mymail_check_port('smtp.gmail.com', 587),
		'--',
		"PHP Version" =>           PHP_VERSION ,
		"MySQL Version" =>         mysql_get_server_info() ,
		"Web Server Info" =>       $_SERVER['SERVER_SOFTWARE'] ,
		"Multi-site" =>            is_multisite() ? 'Yes' . "\n" : 'No',
		'--',
		"PHP Safe Mode" =>         ini_get( 'safe_mode' ) ? "Yes" : "No",
		"PHP Memory Limit" =>      ini_get( 'memory_limit' ) ,
		"PHP Post Max Size" =>     ini_get( 'post_max_size' ) ,
		"PHP Time Limit" =>        ini_get( 'max_execution_time' ) . " sec",
		'--',
		"WP_DEBUG" =>              defined( 'WP_DEBUG' ) ? WP_DEBUG ? 'Enabled' : 'Disabled' : 'Not set',
		'--',
		"WP Table Prefix" =>       "Length: ". strlen( $wpdb->prefix ) . " Status:". ( strlen( $wpdb->prefix )>16  ? " ERROR: Too Long" : " Acceptable" ),
		'--',
		"Session" =>               isset( $_SESSION ) ? 'Enabled' : 'Disabled',
		"Session Name" =>          esc_html( ini_get( 'session.name' ) ),
		"Cookie Path" =>           esc_html( ini_get( 'session.cookie_path' ) ),
		"Save Path" =>             esc_html( ini_get( 'session.save_path' ) ),
		"Use Cookies" =>           ini_get( 'session.use_cookies' ) ? 'On' : 'Off',
		"Use Only Cookies" =>      ini_get( 'session.use_only_cookies' ) ? 'On' : 'Off',
		'--',
		"UPLOAD_MAX_FILESIZE" =>   ( function_exists( 'phpversion' ) ) ? ( size_format ( ini_get( 'upload_max_filesize' )*1048576 ) ) : 'unknown',
		"POST_MAX_SIZE" =>         ( function_exists( 'phpversion' ) ) ? ( size_format ( ini_get( 'post_max_size' )*1048576 ) ) : 'unknown',
		"WordPress Memory Limit" =>( size_format( WP_MEMORY_LIMIT*1048576 ) ) ,
		"DISPLAY ERRORS" =>        ( ini_get( 'display_errors' ) ) ? 'On (' . ini_get( 'display_errors' ) . ')' : 'N/A',
		"FSOCKOPEN" =>             ( function_exists( 'fsockopen' ) ) ? 'Your server supports fsockopen.' : 'Your server does not support fsockopen.',
		'--',
		"ACTIVE PLUGINS" =>        '',
		'--',
		"CURRENT THEME" =>        '',
);
$plugins = get_plugins();
$active_plugins = get_option( 'active_plugins', array() );

foreach ( $plugins as $plugin_path => $plugin ):
	// If the plugin isn't active, don't show it.
	if ( ! in_array( $plugin_path, $active_plugins ) )
		continue;
		
	$settings['ACTIVE PLUGINS'] .= $plugin['Name'].': '.$plugin['Version'] ."\n".str_repeat(' ', $space);

endforeach;

if ( get_bloginfo( 'version' ) < '3.4' ) {
	$theme_data = get_theme_data( get_stylesheet_directory() . '/style.css' );
	$settings['CURRENT THEME'] = $theme_data['Name'] . ': ' . $theme_data['Version']."\n".str_repeat(' ', $space).$theme_data['Author'].' ('.$theme_data['AuthorURI'].')';
} else {
	$theme_data = wp_get_theme();
	$settings['CURRENT THEME'] = $theme_data->Name . ': ' . $theme_data->Version."\n".str_repeat(' ', $space).$theme_data->get('Author').' ('.$theme_data->get('AuthorURI').')';
}	
?>
<div class="wrap">
	<h2><?php _e( 'System Information', 'mymail' ) ?></h2><br/>
	<textarea readonly class="code" onclick="this.focus();this.select()" style="width:100%; height:600px" title="<?php _e( 'To copy the system info, click below then press Ctrl + C (PC) or Cmd + C (Mac).', 'mymail' ); ?>">
### Begin System Info ###

## Please include this information when posting support requests ##

<?php 
	ob_start();
	
	$settings = apply_filters( 'mymail_system_info' , $settings );

	foreach($settings as $name => $value){
		if($value == '--'){
			echo "\n";
			continue;
		}
		echo $name.str_repeat(' ', $space-strlen($name)).$value."\n";
	}
	
	$output = ob_get_contents();
	//echo base64_encode($output);
?>



### End System Info ###
	</textarea>
	<p class="description"><?php _e( 'To copy the system info, click below then press Ctrl + C (PC) or Cmd + C (Mac).', 'mymail' ); ?></p>
</div>


<div id="ajax-response"></div>
<br class="clear">
</div>
